SystemOrganization addCategory: #'MC2-Installer-Base'!

Object subclass: #MDInstaller
	instanceVariableNames: 'hasMonticello'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Installer-Base'!

!MDInstaller class methodsFor: 'installing' stamp: 'cwp 5/3/2006 00:30'!
initialize! !

!MDInstaller class methodsFor: 'installing' stamp: 'cwp 5/3/2006 00:30'!
install
	self new install! !

!MDInstaller methodsFor: 'installing' stamp: 'cwp 5/10/2006 00:01'!
doInstall
	 | repository loader |
	loader := MCVersionLoader new.
	repository := self repository.
	MCRepositoryGroup default addRepository: repository.
	self files do: 
		[:filename | | version |
		version := repository loadVersionFromFileNamed: filename.
		loader addVersion: version].
	loader load.
        ! !

!MDInstaller methodsFor: 'configuration' stamp: 'cwp 4/16/2007 22:06'!
files
	^ #(
	'ToolBuilder-Kernel-cwp.16.mcz'
	'ToolBuilder-Morphic-ar.17.mcz'
	'ToolBuilder-Specs-ar.1.mcz'
	'ToolBuilder-SUnit-cwp.11.mcz'
	'MC2-SqueakPlatform-cwp.5.mcz'
	'Monticello2-cwp.148.mcz'
	'MC2-Squeak-cwp.16.mcz'
	)
! !

!MDInstaller methodsFor: 'preparation' stamp: 'cwp 5/3/2006 00:06'!
fixDependencyBug
	MczInstaller compile: 'versions: aVersionList anySatisfy: aDependencyID
	^ aVersionList anySatisfy: [:version | 
			aDependencyID = (version at: #id)
				or: [self 
						versions: (version at: #ancestors ifAbsent: [^ false]) 
						anySatisfy: aDependencyID]]
'
! !

!MDInstaller methodsFor: 'testing' stamp: 'cwp 5/3/2006 00:06'!
hasMonticello
	^ Smalltalk hasClassNamed: 'MCReader'
! !

!MDInstaller methodsFor: 'installing' stamp: 'cwp 5/3/2006 00:06'!
install
	self shouldInstall ifTrue: [self doInstall]! !

!MDInstaller methodsFor: 'installing' stamp: 'cwp 4/16/2007 22:32'!
installMC
	MczInstaller installStream: (HTTPSocket httpGet: self mcUrl)! !

!MDInstaller methodsFor: 'configuration' stamp: 'cwp 4/16/2007 22:31'!
mcUrl
	^ 'http://source.wiresong.ca/mc/Monticello-avi.279.mcz'! !

!MDInstaller methodsFor: 'testing' stamp: 'cwp 5/3/2006 00:19'!
noPreviousVersion
	^ (Smalltalk hasClassNamed: 'MDVersion') not! !

!MDInstaller methodsFor: 'preparation' stamp: 'cwp 5/9/2006 23:33'!
offerToInstallMC
	| ok |
	ok := self confirm: 'To install Monticello 2,
you must have Monticello installed. Would you like to install it now?'.
	ok ifTrue: [self installMC].
	^ ok! !

!MDInstaller methodsFor: 'accessing' stamp: 'cwp 5/3/2006 00:06'!
repository
	^ MCHttpRepository 
		location: self repositoryUrl 
		user: ''
		password: ''! !

!MDInstaller methodsFor: 'configuration' stamp: 'cwp 4/16/2007 22:09'!
repositoryUrl
	^ 'http://source.wiresong.ca/mc'! !

!MDInstaller methodsFor: 'testing' stamp: 'cwp 5/10/2006 00:02'!
shouldInstall
	^ self hasMonticello
		or: [self offerToInstallMC]! !

!MDInstaller methodsFor: 'accessing' stamp: 'cwp 5/3/2006 00:06'!
versionName
	^ self files last! !
MDInstaller initialize!
